<template>
  <div class="q-pa-sm">
    <div class="row">
      <div class="col">
        <step1
            v-if="step == 1"
            @prevStep="prevStep"
            @nextStep="nextStep"
      />
        <keep-alive>
          <step2
            v-if="step == 2"
            :product="product"
            @prevStep="prevStep"
            @nextStep="nextStep"
            @sendCustomForm="sendCustomForm"
          />
          <step3
            v-if="step == 3"
            :product="product"
            :custom_form="custom_form"
            @prevStep="prevStep(product)"
            @submitProduct="submitProduct(product)"
          />
        </keep-alive>
      </div>
    </div>
  </div>
</template>
<script>
import Step1 from "components/Product/Step1";
import Step2 from "components/Product/Step2";
import Step3 from "components/Product/Step3";
export default {
  name: 'CreateProduct',
  components: {
    Step1,
    Step2,
    Step3
  },
  data() {
    return {
      step: this.$route.params.step || 1,
      product: null,
      custom_form: null,
    }
  },
  preFetch ( product ) {
    product.store.dispatch("ProductType/getSelectProductType");
    product.store.dispatch("kategori/getSelectkategori");
  },
  methods: {
    prevStep(product) {
      this.product = product
      if (this.$step != 1) {
        this.step = parseInt(this.step) - parseInt(1);
      }
    },
    nextStep(products) {
      this.product = products
      if (this.step != 3) {
        this.step = parseInt(this.step) + parseInt(1)
      }
    },
    submitProduct(product) {
      this.$q.loading.show()
      this.$axios.post("api/product/ubahstatus/diperiksa", {idProduct: product.id})
        .then(sukses => {
          this.$q.loading.hide()
          this.$router.push("/produk/saya")
        })
        .catch(gagal => {
          this.$q.loading.hide()
        })
    },
    sendCustomForm(custom) {
      this.custom_form = custom;
    }
  }
}
</script>
